Summary: The GNU data compression program.
Name: gzip
Version: 1.3.5
Release: 8tr
License: GPL
Group: Trustix Official
Source: ftp://alpha.gnu.org/gnu/gzip/gzip-%{version}.tar.gz
Patch: gzip-1.3.3-basename.patch
Patch1: gzip-1.3.3-gzexe.patch
Patch2: gzip-1.3.3-zforce.patch
Patch3: gzip-1.3-openbsd-owl-tmp.diff
Patch4: gzip.dirtraversal_better.patch
Patch5: gzip-race.patch
Patch6: gzip-1.3.5-CAN-2005-0758.patch
Patch7: gzip-1.3.5-sec.patch
Requires: mktemp
BuildRequires: texinfo
Buildroot: /var/tmp/gzip-root

%description
The gzip package contains the popular GNU gzip data compression
program.  Gzipped files have a .gz extension.  

Gzip should be installed on your Trustix Secure Linux system, because it is a
very commonly used data compression program.

%prep
%setup -q
%patch -p1
#%patch1 -p1
#%patch2 -p1
%patch3 -p1
%patch4 -p0
%patch5 -p0
%patch6 -p0
%patch7 -p1

%package doc
Summary: html formatted Info-files for Gzip
Group: Trustix Official
Requires: gzip
Prereq: htmlinfo

%description doc
This package contains the documentation files for Gzip

%build
./configure --prefix=/usr
make CFLAGS="$RPM_OPT_FLAGS" LDFLAGS=-s
makeinfo --html --no-split %{name}.texi


%install
[ -n "$RPM_BUILD_ROOT" -a "$RPM_BUILD_ROOT" != "/" ] && rm -rf "$RPM_BUILD_ROOT"
mkdir -p $RPM_BUILD_ROOT/{bin,usr/share/{man,html/%{name}}}
make install prefix=$RPM_BUILD_ROOT/usr \
    infodir=$RPM_BUILD_ROOT/usr/share/info \
    mandir=$RPM_BUILD_ROOT/usr/share/man/
strip $RPM_BUILD_ROOT/usr/bin/gzip
cp %{name}.html $RPM_BUILD_ROOT/usr/share/html/%{name}/
mv -f $RPM_BUILD_ROOT/usr/bin/gzip $RPM_BUILD_ROOT/bin/gzip
rm -f $RPM_BUILD_ROOT/usr/bin/gunzip $RPM_BUILD_ROOT/usr/bin/zcat
rm -Rf $RPM_BUILD_ROOT%{_prefix}/share/info
ln -f $RPM_BUILD_ROOT/bin/gzip $RPM_BUILD_ROOT/bin/gunzip
ln -f $RPM_BUILD_ROOT/bin/gzip $RPM_BUILD_ROOT/bin/zcat
ln -sf ../../bin/gzip $RPM_BUILD_ROOT/usr/bin/gzip
ln -sf ../../bin/gunzip $RPM_BUILD_ROOT/usr/bin/gunzip
mkdir -p $RPM_BUILD_ROOT%{_datadir}/html/%{name}
install -m 644 %{name}.html $RPM_BUILD_ROOT%{_datadir}/html/%{name}/

for i in zcmp zdiff zforce zgrep zmore znew ; do
	sed -e "s|$RPM_BUILD_ROOT||g" < $RPM_BUILD_ROOT/usr/bin/$i > $RPM_BUILD_ROOT/usr/bin/.$i
	rm -f $RPM_BUILD_ROOT/usr/bin/$i
	mv $RPM_BUILD_ROOT/usr/bin/.$i $RPM_BUILD_ROOT/usr/bin/$i
	chmod 755 $RPM_BUILD_ROOT/usr/bin/$i
done

cat > $RPM_BUILD_ROOT/usr/bin/zless <<EOF
#!/bin/sh
/bin/zcat "\$@" | /usr/bin/less
EOF
chmod 755 $RPM_BUILD_ROOT/usr/bin/zless

%post doc
/usr/sbin/htmlinfo_update.sh

%postun doc
/usr/sbin/htmlinfo_update.sh

%clean
[ -n "$RPM_BUILD_ROOT" -a "$RPM_BUILD_ROOT" != / ] && rm -rf $RPM_BUILD_ROOT


%files
%defattr(-,root,root,0755)
/bin/*
/usr/bin/*

%files doc
%defattr(-,root,root,0755)
%doc NEWS README
/usr/share/html/%{name}
/usr/share/man/*

%changelog
* Mon Feb 26 2007 Nived Gopalan <nived at trustix dot org>
- Rebuilt

* Thu Sep 21 2006 Nived Gopalan <nived at trustix dot org> 1.3.5-7tr
- SECURITY Fix: Tavis Ormandy, Google Security Team,  has reported some
  vulnerabilities in gzip, which can be exploited by malicious people
  to cause a DoS and potentially compromise a vulnerable system.
- Fix null pointer dereference that may lead to denial of service if
  gzip is used in an automated manner.
- A boundary error within the "make_table()" function in unlzh.c can be
  used to modify certain stack data. This can be exploited to cause a DoS
  and potentially allows to execute arbitrary code.
- A buffer underflow exists within the "build_tree()" function in
  unpack.c, which can be exploited to cause a DoS and potentially allows
  to execute arbitrary code.
- A buffer overflow within the "make_table()" function of gzip's LZH
  support can be exploited to cause a DoS and potentially to compromise
  a vulnerable system by e.g. tricking a user or automated system into
  unpacking an archive containing a specially crafted decoding table.
- unlzh.c in the LHZ component in gzip allows context-dependent attackers
  to cause a denial of service (infinite loop) via a crafted GZIP archive.

  The Common Vulnerabilities and Exposures project (cve.mitre.org) has
  assigned the names CVE-2006-4334, CVE-2006-4335, CVE-2006-4336,
  CVE-2006-4337 and CVE-2006-4338 to these issues.

* Fri May 20 2005 Syed Shabir Zakiullah <syedshabir at comodo dot com> 1.3.5-5tr
- Fix Multiple vulnerabilities: The zgrep utility improperly
  sanitizes arguments, which may come from an untrusted source
  (CAN-2005-0758).

* Fri May  6 2005 Chr. Toldnes <christht at trustix dot org> 1.3.5-4tr
- Added a better patch for CAN-2005-1228 that does not break rpm builds.

* Thu May 05 2005 Ajith Thampi <ajith at comodo dot com> 1.3.5-3tr
- Ulf Härnhammar <metaur@telia.com> has discovered a vulnerability in
  gunzip that allows a malicious zip file to extract to an arbitrary
  directory of the attackers choice when gunzip is used with the -N
  option.(CAN-2005-1228)
- A race condition error in the file permission restore code, which may
  be exploited by a malicious local user, with write permissions, to gain
  read or write access to files of other users.(CAN-2005-0988)

* Thu Mar 17 2005 Lakshmi Dinamoni <lakshmi at comodo dot com> 1.3.5-2tr
- Fix unpackaged files 

* Mon Feb 21 2005 Raghu <raghu at comodo dot com> 1.3.5-1tr
- New Upstream

* Fri Dec 03 2004 Syed Shabir <syedshabir at comodo dot com>
- Fix man page bug BugZilla Id: 17

* Tue Nov  9 2004 Erlend Midttun <erlendbm at trustix dot org> 1.3.3-4tr
- Now own /usr/share/html/%{name}

* Mon Nov  1 2004 Oystein Viggen <oysteivi at trustix dot com> 1.3.3-3tr
- Patch tempfile issues (Patch taken from Openwall GNU/*/Linux)

* Thu Sep 23 2004 Syed Shabir <syedshabir at comodo dot com> 1.3.3-2tr
- New upstream

* Mon Dec  1 2003 Erlend Midttun <erlendbm at trustix dot org> 1.2.4a-26tr
- Big rebuild

* Mon Oct 20 2003 Michael Scheffler <duke at tawie dot org> 1.2.4a-25ms
- Added 64bit file support

* Mon Jun 23 2003 Erlend Midttun <erlendbm at trustix dot com> 1.2.4a-24tr
- Added %defattr.

* Wed Jun 18 2003 Erlend Midttun <erlendbm at trustix dot com> 1.2.4a-23tr
- Big rebuild

* Tue Mar 25 2003 Erlend Midttun <erlendbm at trustix dot com> 1.2.4a-22em
- Fix typo.

* Mon Mar 24 2003 Erlend Midttun <erlendbm at trustix dot com> 1.2.4a-21em
- Rebuilt against glibc 2.3.2.

* Thu Oct 24 2002 Christian H. Toldnes <christht at trustix dot com> 1.2.4a-20ct
- Replaced info stuff with htmlinfo

* Wed Jul 24 2002 Daniel Meyer <eagle at trustix dot org> 1.2.4a-19dm
- rebuild for Trustix Secure Linux 2.0

* Tue Jan 15 2002 Hans Almsbakk <hansa at trustix dot com>
- Applied patch that fixes a potential buffer overflow on too long input 
  filename.

* Mon Feb 28 2000 Lars Gaarden <larsg at trustix dot com>
- put the documentation in a separate package

* Sun Mar 21 1999 Cristian Gafton <gafton@redhat.com> 
- auto rebuild in the new build environment (release 14)

* Thu Dec 17 1998 Cristian Gafton <gafton@redhat.com>
- built against gliibc 2.1

* Thu May 07 1998 Prospector System <bugs@redhat.com>
- translations modified for de, fr, tr

* Thu Apr 09 1998 Cristian Gafton <gafton@redhat.com>
- added /usr/bin/gzip and /usr/bin/gunzip symlinks as some programs are too
  brain dead to figure out they should be at least trying to use $PATH
- added BuildRoot

* Wed Jan 28 1998 Erik Troan <ewt@redhat.com>
- fix /tmp races

* Sun Sep 14 1997 Erik Troan <ewt@redhat.com>
- uses install-info
- applied patch for gzexe

* Mon Jun 02 1997 Erik Troan <ewt@redhat.com>
- built against glibc

* Tue Apr 22 1997 Marc Ewing <marc@redhat.com>
- (Entry added for Marc by Erik) fixed gzexe to use /bin/gzip

